import BorderBottomItem from "@/components/borderBottomItem";
import ButtonBackHeader from "@/components/buttonBackHeader";
import ButtonSaveHeader from "@/components/buttonSaveHeader";
import ButtonSelect from "@/components/buttonSelect";
import DrawerBottom from "@/components/drawerBottom";
import ImageUser from "@/components/imageNew";
import { InputForm } from "@/components/inputForm";
import MenuItemRow from "@/components/menuItemRow";
import ModalSelect from "@/components/modalSelect";
import SectionListAddTask from "@/components/project/sectionListAddTask";
import SelectForm from "@/components/selectForm";
import Text from "@/components/Text";
import { ConstEnv } from "@/constants/ConstEnv";
import Styles from "@/constants/Styles";
import { apiCreateProject } from "@/lib/api";
import { setGroupChoose } from "@/lib/groupChoose";
import { setMemberChoose } from "@/lib/memberChoose";
import { setUpdateProject } from "@/lib/projectUpdate";
import { setTaskCreate } from "@/lib/taskCreate";
import { useAuthSession } from "@/providers/AuthProvider";
import { Ionicons, MaterialCommunityIcons } from "@expo/vector-icons";
import * as DocumentPicker from "expo-document-picker";
import { router, Stack } from "expo-router";
import { useEffect, useState } from "react";
import {
   SafeAreaView,
   ScrollView,
   View
} from "react-native";
import Toast from "react-native-toast-message";
import { useDispatch, useSelector } from "react-redux";

export default function CreateProject() {
   const [loading, setLoading] = useState(false)
   const { token, decryptToken } = useAuthSession();
   const [chooseGroup, setChooseGroup] = useState({ val: "", label: "" });
   const dispatch = useDispatch();
   const [valSelect, setValSelect] = useState<"group" | "member">("group");
   const [isSelect, setSelect] = useState(false);
   const [valChoose, setValChoose] = useState("");
   const entitiesMember = useSelector((state: any) => state.memberChoose);
   const taskCreate = useSelector((state: any) => state.taskCreate);
   const update = useSelector((state: any) => state.projectUpdate)
   const entityUser = useSelector((state: any) => state.user);
   const userLogin = useSelector((state: any) => state.entities)
   const [fileForm, setFileForm] = useState<any[]>([])
   const [indexDelFile, setIndexDelFile] = useState<number>(0)
   const [disableBtn, setDisableBtn] = useState(true)
   const [isModal, setModal] = useState(false)
   const [dataForm, setDataForm] = useState({
      idGroup: "",
      title: "",
   });
   const [error, setError] = useState({
      group: false,
      title: false,
      task: false,
      member: false,
   });
   const [hitung, setHitung] = useState(0)
   let hitungRefresh = 0;

   useEffect(() => {
      if (hitungRefresh == 0) {
         dispatch(setGroupChoose(''));
         dispatch(setTaskCreate([]));
         dispatch(setMemberChoose([]));
      }
      hitungRefresh++;
   }, []);

   function validationForm(cat: string, val: any, label?: string) {
      if (cat == "group") {
         setChooseGroup({ val, label: String(label) });
         dispatch(setGroupChoose(val));
         dispatch(setMemberChoose([]));
         setDataForm({ ...dataForm, idGroup: val });
         if (val == "" || val == "null") {
            setError(error => ({ ...error, group: true }))
         } else {
            setError(error => ({ ...error, group: false }))
         }
      } else if (cat == "title") {
         setDataForm({ ...dataForm, title: val });
         if (val == "" || val == "null") {
            setError(error => ({ ...error, title: true }))
         } else {
            setError(error => ({ ...error, title: false }))
         }
      } else if (cat == "task" && hitung > 2) {
         if (taskCreate.length == 0) {
            setError(error => ({ ...error, task: true }))
         } else {
            setError(error => ({ ...error, task: false }))
         }
      } else if (cat == "member") {
         if (entitiesMember.length == 0) {
            setError(error => ({ ...error, member: true }))
         } else {
            setError(error => ({ ...error, member: false }))
         }
      }

      setHitung(hitung => hitung + 1)
   }

   function handleBack() {
      dispatch(setGroupChoose(''));
      dispatch(setTaskCreate([]));
      dispatch(setMemberChoose([]));
      router.back();
   }

   useEffect(() => {
      validationForm('task', '');
   }, [taskCreate]);


   useEffect(() => {
      if (entityUser.role != "supadmin" && entityUser.role != "developer") {
         validationForm('group', userLogin.idGroup, userLogin.group);
      }
   }, []);

   async function handleCreate() {
      try {
         setLoading(true)
         const hasil = await decryptToken(String(token?.current))
         const fd = new FormData()

         for (let i = 0; i < fileForm.length; i++) {
            fd.append(`file${i}`, {
               uri: fileForm[i].uri,
               type: 'application/octet-stream',
               name: fileForm[i].name,
            } as any);
         }

         fd.append("data", JSON.stringify(
            { user: hasil, task: taskCreate, member: entitiesMember, ...dataForm }
         ))

         const response = await apiCreateProject(fd)
         if (response.success) {
            dispatch(setUpdateProject({ ...update, data: !update.data }))
            Toast.show({ type: 'small', text1: 'Berhasil menambahkan data', })
            handleBack()
         } else {
            Toast.show({ type: 'small', text1: response.message, })
         }
      } catch (error) {
         console.error(error)
         Toast.show({ type: 'small', text1: 'Terjadi kesalahan', })
      } finally {
         setLoading(false)
      }
   }


   function checkForm() {
      if (Object.values(error).some((v) => v == true) == true || Object.values(dataForm).some((v) => v == "") == true || entitiesMember.length == 0 || taskCreate.length == 0) {
         setDisableBtn(true)
      } else {
         setDisableBtn(false)
      }
   }

   useEffect(() => {
      checkForm()
   }, [error, dataForm, entitiesMember, taskCreate])

   const pickDocumentAsync = async () => {
      let result = await DocumentPicker.getDocumentAsync({
         type: ["*/*"],
         multiple: true
      });
      if (!result.canceled) {
         for (let i = 0; i < result.assets?.length; i++) {
            if (result.assets[i].uri) {
               setFileForm((prev) => [...prev, result.assets[i]])
            }
         }
      }
   };

   function deleteFile(index: number) {
      setFileForm([...fileForm.filter((val, i) => i !== index)])
      setModal(false)
   }


   return (
      <SafeAreaView>
         <Stack.Screen
            options={{
               headerLeft: () => (
                  <ButtonBackHeader
                     onPress={() => {
                        handleBack();
                     }}
                  />
               ),
               headerTitle: "Tambah Kegiatan",
               headerTitleAlign: "center",
               headerRight: () => (
                  <ButtonSaveHeader
                     disable={disableBtn || loading}
                     category="create"
                     onPress={() => {
                        handleCreate()
                     }}
                  />
               ),
            }}
         />
         <ScrollView
            showsVerticalScrollIndicator={false}
            style={[Styles.h100]}
         >
            <View style={[Styles.p15]}>
               {
                  (entityUser.role == "supadmin" || entityUser.role == "developer")
                  &&
                  (
                     <SelectForm
                        label="Lembaga Desa"
                        placeholder="Pilih Lembaga Desa"
                        value={chooseGroup.label}
                        required
                        onPress={() => {
                           setValChoose(chooseGroup.val);
                           setValSelect("group");
                           setSelect(true);
                        }}
                        error={error.group}
                        errorText="Lembaga Desa tidak boleh kosong"
                     />
                  )
               }
               <InputForm
                  label="Kegiatan"
                  type="default"
                  placeholder="Nama Kegiatan"
                  required
                  value={dataForm.title}
                  error={error.title}
                  errorText="Nama kegiatan tidak boleh kosong"
                  onChange={(val) => {
                     validationForm("title", val);
                  }}
               />
               <ButtonSelect
                  value="Tambah Tanggal & Tugas"
                  onPress={() => {
                     router.push(`/project/create/task`);
                  }}
                  error={error.task}
                  errorText="Tanggal & Tugas tidak boleh kosong"
               />
               <ButtonSelect value="Upload File" onPress={pickDocumentAsync} />
               <ButtonSelect
                  value="Pilih Anggota"
                  onPress={() => {
                     if (entityUser.role == "supadmin" || entityUser.role == "developer") {
                        if (chooseGroup.val != "") {
                           router.push(`/project/create/member`);
                        } else {
                           Toast.show({ type: 'small', text1: "Pilih Lembaga Desa terlebih dahulu", })
                        }
                     } else {
                        router.push(`/project/create/member`);
                     }
                  }}
                  error={error.member}
                  errorText="Anggota tidak boleh kosong"
               />
               <SectionListAddTask />
               {
                  fileForm.length > 0 && (
                     <View style={[Styles.mb15]}>
                        <Text style={[Styles.textDefaultSemiBold, Styles.mv05]}>File</Text>
                        <View style={[Styles.wrapPaper]}>
                           {
                              fileForm.map((item, index) => (
                                 <BorderBottomItem
                                    key={index}
                                    borderType="all"
                                    icon={<MaterialCommunityIcons name="file-outline" size={25} color="black" />}
                                    title={item.name}
                                    titleWeight="normal"
                                    onPress={() => { setIndexDelFile(index); setModal(true) }}
                                 />
                              ))
                           }
                        </View>
                     </View>
                  )
               }
               {entitiesMember.length > 0 && (
                  <View>
                     <View style={[Styles.rowSpaceBetween, Styles.mv05]}>
                        <Text>Anggota</Text>
                        <Text>Total {entitiesMember.length} Anggota</Text>
                     </View>

                     <View style={[Styles.borderAll, Styles.round10, Styles.p10]}>
                        {entitiesMember.map(
                           (item: { img: any; name: any }, index: any) => {
                              return (
                                 <BorderBottomItem
                                    key={index}
                                    borderType="bottom"
                                    icon={
                                       <ImageUser
                                          src={`${ConstEnv.url_storage}/files/${item.img}`}
                                          size="sm"
                                       />
                                    }
                                    title={item.name}
                                 />
                              );
                           }
                        )}
                     </View>
                  </View>
               )}
            </View>
         </ScrollView>
         <DrawerBottom animation="slide" isVisible={isModal} setVisible={setModal} title="Menu">
            <View style={Styles.rowItemsCenter}>
               <MenuItemRow
                  icon={<Ionicons name="trash" color="black" size={25} />}
                  title="Hapus"
                  onPress={() => { deleteFile(indexDelFile) }}
               />
            </View>
         </DrawerBottom>

         <ModalSelect
            category={valSelect}
            close={setSelect}
            onSelect={(value) => {
               validationForm(valSelect, value.val, value.label);
            }}
            title={valSelect == "group" ? "Lembaga Desa" : "Pilih Anggota"}
            open={isSelect}
            idParent={valSelect == "member" ? chooseGroup.val : ""}
            valChoose={valChoose}
         />
      </SafeAreaView>
   );
}
